"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const express_1 = __importDefault(require("express"));
const context_1 = require("../context");
class Server extends react_1.default.Component {
    constructor(props) {
        super(props);
        this.app = (0, express_1.default)();
        this.shouldComponentUpdate = (nextProps) => {
            if (nextProps.listen !== this.props.listen ||
                nextProps.port !== this.props.port) {
                if (nextProps.listen !== this.props.listen && !nextProps.listen) {
                    if (this.server)
                        this.server.close();
                }
                if (nextProps.port !== this.props.port) {
                    if (nextProps.listen) {
                        if (this.props.listen) {
                            if (this.server)
                                this.server.close();
                        }
                        this.server = this.app.listen(nextProps.port);
                        if (this.props.then)
                            this.server.on("close", this.props.then);
                    }
                }
                else {
                    if (nextProps.listen !== this.props.listen && nextProps.listen) {
                        this.server = this.app.listen(nextProps.port);
                        if (this.props.then)
                            this.server.on("close", this.props.then);
                    }
                }
            }
            if (!this.props.reference && nextProps.reference) {
                nextProps.reference(this.app, this.server);
            }
            this.app.listen();
            return false;
        };
        this.componentWillUnmount = () => {
            if (this.server)
                this.server.close();
        };
        if (props.listen && props.port) {
            this.server = this.app.listen(this.props.port);
            if (props.then)
                this.server.on("close", props.then);
            if (props.reference)
                props.reference(this.app, this.server);
        }
    }
    render() {
        return (react_1.default.createElement(context_1.ApplicationContext.Provider, { value: this.app }, this.props.children));
    }
}
exports.default = Server;
